﻿using System;
using Xamarin.Forms;
//using Xamarin.Forms.Labs.Controls;

namespace TaskPageChase
{
	public class TaskPage : ContentPage
	{
		public TaskPage()
		{
			BackgroundColor = Color.White;
			var viewModel = new TaskPageViewModel();
			BindingContext = viewModel;

			var grid = new GridView {
				HorizontalOptions = LayoutOptions.FillAndExpand,
				VerticalOptions = LayoutOptions.FillAndExpand,
				ItemTemplate = new DataTemplate(typeof(CustomCell)),
				RowSpacing = 5,
				Padding = 5,
				ColumnSpacing = 5,
				ItemWidth = 400,
				ItemHeight = 300,
			};

			grid.SetBinding<TaskPageViewModel>(
				GridView.ItemsSourceProperty,
				vm => vm.Tasks,
				BindingMode.Default
			);

			var androidGrid = new GridViewUsingAndroidLayout {
				HorizontalOptions = LayoutOptions.FillAndExpand,
				VerticalOptions = LayoutOptions.FillAndExpand,
				ItemTemplate = new DataTemplate(typeof(CustomCell)),
				RowSpacing = 5,
				Padding = 5,
				ColumnSpacing = 5,
				ItemWidth = 400,
				ItemHeight = 300,
			};

			androidGrid.SetBinding<TaskPageViewModel>(
				GridView.ItemsSourceProperty,
				vm => vm.Tasks,
				BindingMode.Default
			);

			var stack = new StackLayout {
				BackgroundColor = Color.Transparent,
				HorizontalOptions = LayoutOptions.FillAndExpand,
				VerticalOptions = LayoutOptions.FillAndExpand,
				Orientation = StackOrientation.Vertical,
				Children = { grid, androidGrid }
			};

			Content = stack;
		}
	}

	public class CustomCell : ViewCell
	{
		public CustomCell()
		{
			var label = new Label
			{
				VerticalOptions = LayoutOptions.CenterAndExpand,
				HorizontalOptions = LayoutOptions.CenterAndExpand,
				TextColor = Color.White
			};

			label.SetBinding<TaskModel>(
				Label.TextProperty,
				c => c.Name,
				BindingMode.Default
			);

//			var stack = new StackLayout {
//				BackgroundColor = Color.Teal,
//				HorizontalOptions = LayoutOptions.FillAndExpand,
//				VerticalOptions = LayoutOptions.FillAndExpand,
//				Orientation = StackOrientation.Vertical,
//				Children = { label }
//			};

			View = label;
		}
	}
}

